/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 04 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

#define N 5

void aeiou(
  int position, int n_char, int reps_allowed,
  char *sol, char alfa[], int taken[]
) {
  int i;

  if (position == n_char) {
    for (i=0; i<n_char; i++) {
      fprintf (stdout, "%c", sol[i]);
    }
    fprintf (stdout, "\n");
    return;
  }

  for (i=0; i<N; i++) {
    if (!taken[i]) {
      taken[i] = 1;
      sol[position] = alfa[i];
      aeiou(position+1, n_char, reps_allowed,sol,alfa,taken);
      taken[i] = 0;
    } else {
      if (taken[i] && reps_allowed > 0) {
        sol[position] = alfa[i];
        aeiou(position+1, n_char, reps_allowed-1,sol,alfa,taken);
      }
    }
  }
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
