/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 16 - solution (3-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

int tree_isomorphism (struct node *t1, struct node *t2) {
  if (t1==NULL && t2==NULL){
    return (1);
  }
  if (t1==NULL && t2!=NULL){
    return (0);
  }
  if (t1!=NULL && t2==NULL){
    return (0);
  }
  if (t1->key!=t2->key){
    return (0);
  }
  if (tree_isomorphism (t1->left, t2->left) == 0) {
    return (0);
  }
  if (tree_isomorphism (t1->right, t2->right) == 0) {
    return (0);
  }
  return (1);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
