/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 24 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

int subMat_max (int **mat, int r, int c, int n)
{
  int r1, r2, c1, c2, sum, largest;

  largest = (-1);
  for (r1=0; r1<=(r-n); r1++) {
    for (c1=0; c1<=(c-n); c1++) {
      sum = 0;
      for (r2=0; r2<n; r2++) {
        for (c2=0; c2<n; c2++) {
          sum += mat[r1+r2][c1+c2];
        }
      }
      if (largest==(-1) || (sum>largest)) {
        largest = sum;
      }
    }
  }

  return largest;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
