/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 28 - solution (2-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

/* Version 1 */
void subMat_copy_ver1 (
  int **m1, int r1, int c1, int **m2, int r2, int c2, int x, int y
) {
  int i, j;

  if (x>=r1 || y>=c1 || x<0 || y<0)
    return;

  for (i=0; i<r2 && i<(r1-x); i++) {
    for(j=0; j<c2 && j<(c1-y); j++) {
      m1[i+x][j+y] = m2[i][j];    
    }
  }

  return;
}

/* Version 2 */
void subMat_copy_ver2 (
  int **m1, int r1, int c1, int **m2, int r2, int c2, int x, int y
) {
  int i1, j1, i2, j2;

  for (i1=x, i2=0; i1<r1 && i2<r2; i1++, i2++) {
    for (j1=y, j2=0; j1<c1 && j2<c2; j1++, j2++) {
      m1[i1][j1] = m2[i2][j2];    
    }
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
