/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 12 - solution (4-1)
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#define L 5

void password (char *pass, int level, int *letter, int *digit, int n) {
  static int stop = 0, STOP = 1000; // Stop after STOP password
  int i;

  if (level == L) {
    for (i=0; i<L; i++) {
      fprintf (stdout, "%c", pass[i]);
    }
    fprintf (stdout, "\n");

    stop++;
    if (stop==STOP) {
      fprintf (stdout, "End program.\n");
      exit(EXIT_FAILURE);
    }

    return;
  }

  if (level<3) {
    // Select a letter
    for (i=0; i<26; i++) {
      if (letter[i]<n) {
        letter[i]++;
        pass[level] = (char) (((int) 'a') + i);
        password (pass, level+1, letter, digit, n);
        letter[i]--;
      }
    }
  } else {
    // Select a digit
    for (i=0; i<10; i++) {
      if (digit[i]<n) {
        digit[i]++;
        pass[level] = (char) (((int) '0') + i);
        password (pass, level+1, letter, digit, n);
        digit[i]--;
      }
    }
  }


  return;
}


/*
 * Copyright C.L.U.T. - Torino - Ottobre 2017
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
